<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns="http://www.kit.edu/FeatureCatalogue/1.0"
    xmlns:doc="http://www.kit.edu/FeatureCatalogue/1.0" version="1.0">
       
    <xsl:output method="html" version="4.01"/>
    
    <xsl:template match="doc:TypeDocumentation">            
    <html>  
        <head>
            <title>Objektart</title>    
            
            <style type="text/css">
                        
                        <xsl:text disable-output-escaping="yes">
                        
tr {
     vertical-align: middle;
     margin-bottom: 0px;
}

table {

}
td {
    vertical-align: middle;
    margin-bottom: 0px;
    margin-top: 0px;
 }
  h1 {
        font-family: Arial, Helvetica, sans-serif;
        font-size: 24px;
 }
h2 {
        font-family: Arial, Helvetica, sans-serif;
        font-size: 20px;
        margin-bottom: 0px;
 }
 
h3 {
        font-family: Arial, Helvetica, sans-serif;
        font-size: 16px;
        margin-bottom: 0px;
 }

 h4 {
        font-family: Arial, Helvetica, sans-serif;
        font-size: 12px;
        margin-top: 0px;
        margin-bottom: 0px;
        margin-left: 10px;
 }

 p {
     font-family: Arial, Helvetica, sans-serif;
     font-size: 15px;
     margin-bottom: 0px;
     margin-top: 0px;
  }

.grau { background-color:#CCCCCC; }
.einzug10 {  margin-left: 10px;
}      
      
    </xsl:text>
   </style>          
        </head>
        
<body>
    <a>
        <xsl:attribute name="name">
            <xsl:value-of select="id"/>   
        </xsl:attribute>   
    </a>
    <h1><xsl:value-of select="doc:name"/></h1>
    
    <h2>Typ</h2>
        <xsl:if test="doc:classification='featureType'">
            <p class="einzug10">Feature Type</p>
        </xsl:if>
        <xsl:if test="doc:classification='objectType'">
            <p class="einzug10">Object Type</p>
        </xsl:if>
        <xsl:if test="doc:classification='dataType'">
            <p class="einzug10">Data Type</p>
        </xsl:if>
        <xsl:if test="doc:classification='union'">
            <p class="einzug10">Union</p>
        </xsl:if>
  
    
    <h2>Definition</h2>
    <p class="einzug10"><xsl:value-of disable-output-escaping="yes" select="doc:description"/></p>
    
    <xsl:if test="doc:abstract='true'">
        <h2><strong>Abstrakte Klasse</strong>
        </h2>
    </xsl:if>

    <h2>Gehört zu Objektbereich</h2>
    <p class="einzug10">
        <a>
            <xsl:attribute name="href">
                <xsl:value-of select="doc:package/doc:packageFile"/>
            </xsl:attribute>                         
            <xsl:value-of select="doc:package/doc:packageName"/>
        </a> 
    </p>
    
    <xsl:if test="doc:supertype/doc:supertypeName!=''">
        <h2>Abgeleitet von</h2>
        <xsl:for-each select="doc:supertype">    
          <p class="einzug10">           
           <a>
               <xsl:if test="doc:supertypeFile!=''">
                 <xsl:attribute name="href">
                     <xsl:value-of select="doc:supertypeFile"/>
                 </xsl:attribute>  
               </xsl:if>  
               <xsl:value-of select="doc:supertypeName"/>            
            </a>
             
        </p>    
        </xsl:for-each>            
    </xsl:if>
    
    <xsl:if test="doc:derivedtype/doc:derivedtypeName!=''">  
        <h2>Abgeleitete Klassen</h2>
        <xsl:for-each select="doc:derivedtype">
            <p class="einzug10">             
                <a>
                  <xsl:if test="doc:derivedtypeFile!=''">
                    <xsl:attribute name="href">
                        <xsl:value-of select="doc:derivedtypeFile"/>
                    </xsl:attribute> 
                   </xsl:if>                       
                  <xsl:value-of select="doc:derivedtypeName"/>                
              </a>             
            </p>    
        </xsl:for-each>

    </xsl:if>
    
    
    <h2>Attribute und Relationen</h2>
    
    <table  width="800" border="0" cellspacing="3">
        <tr>
            <td width="600" height="20"  bgcolor="#9DE5F7">
                <p><strong><em>Bezeichnung</em></strong></p>
            </td>
            
            <td bgcolor="#9DE5F7">
                <p><strong><em>Objekttyp</em></strong></p>
            </td>
        </tr>
        
        <xsl:for-each select="doc:property">  
        <tr>            
        <a>
            <xsl:attribute name="name"><xsl:value-of select="doc:id"/>_A</xsl:attribute>   
        </a>
                    
        <xsl:if test="doc:isADEProperty='false'">
            
            <xsl:if test="doc:inheritedProperty='true'">
            <td width="600" height="20"  bgcolor="#EEEEEE">
             <p>
             <a>
                <xsl:attribute name="href">#<xsl:value-of select="doc:id"/></xsl:attribute>
                        
                <xsl:value-of select="doc:name"/> [<xsl:value-of select="doc:cardinality"/>]
             </a>   
             </p>                 
            </td>
            <td width="600" height="20"  bgcolor="#EEEEEE">
                <p>
                 <xsl:value-of select="doc:propertyType/doc:propertyTypeName"/> 
                </p>                    
            </td>
            </xsl:if>
            
            <xsl:if test="doc:inheritedProperty='false'">
                <td width="600" height="20"  bgcolor="#CCCCCC">
                    <p>
                        <a>
                            <xsl:attribute name="href">#<xsl:value-of select="doc:id"/></xsl:attribute>
                            
                         <xsl:value-of select="doc:name"/>  [<xsl:value-of select="doc:cardinality"/>]
                        </a>   
                    </p>                 
                </td>
                <td width="600" height="20"  bgcolor="#CCCCCC">
                    <p>
                        <xsl:value-of select="doc:propertyType/doc:propertyTypeName"/> 
                    </p>                    
                </td>
            </xsl:if>
            
            
        </xsl:if>
            
            
            <xsl:if test="doc:isADEProperty='true'">
                <td width="600" height="20"  bgcolor="FADB76">
                    <p>
                        <a>
                            <xsl:attribute name="href">#<xsl:value-of select="doc:id"/></xsl:attribute>
                            
                            <xsl:value-of select="doc:name"/> 
                        </a>   
                    </p>                 
                </td>
                <td width="600" height="20"  bgcolor="#FADB76">
                    <p>
                        <xsl:value-of select="doc:propertyType/doc:propertyTypeName"/> 
                    </p>                    
                </td>
            </xsl:if>
            
            
         </tr>
        </xsl:for-each>    
    </table>
    
  
    
    <xsl:for-each select="doc:property"> 
     <br/>         
        <a>
            <xsl:attribute name="name">
                <xsl:value-of select="doc:id"/>
            </xsl:attribute>   
        </a>
        
        <table  width="800" border="0" cellspacing="3" >
            <xsl:if test="doc:inheritedProperty='true'">
                <tr>
                    <td width="600" height="20"  bgcolor="#EEEEEE">
                        <h2>Attribute type: <xsl:value-of select="doc:name"/></h2>
                    </td>
                    
                    <td bgcolor="#EEEEEE">
                        <p><a>
                            <xsl:attribute name="href">#<xsl:value-of select="doc:id"/>_A</xsl:attribute>zurück</a> </p>
                    </td>
                    
                </tr>
            </xsl:if>
            
            <xsl:if test="doc:inheritedProperty='false'">
                <tr>
                    <td width="600" height="20"  bgcolor="#CCCCCC">
                        <h2>Attribute type: <xsl:value-of select="doc:name"/></h2>
                    </td>
                    
                    <td bgcolor="#CCCCCC">
                        <p><a>
                            <xsl:attribute name="href">#<xsl:value-of select="doc:id"/>_A</xsl:attribute>zurück</a> </p>
                    </td>
                    
                </tr>
            </xsl:if>            
        </table> 

        <h3>Definition</h3>
        <p class="einzug10"><xsl:value-of disable-output-escaping="yes" select="doc:description"/></p> 
        
        <h3>Kardinalität</h3>
        <p class="einzug10"><xsl:value-of select="doc:cardinality"/>
            
         <xsl:if test="doc:voidable='true'">
             <xsl:text> (voidable)</xsl:text>           
         </xsl:if>
     
        </p>
        
       <h3>Datentyp</h3>
        
        <xsl:if test="not(doc:propertyType/doc:propertyTypeFile!='')">           
            <p class="einzug10"><xsl:value-of select="doc:propertyType/doc:propertyTypeName"/>
            
                <xsl:if test="doc:stereotype">
                    <xsl:text> (</xsl:text>
                    <xsl:value-of select="doc:stereotype"/>
                    <xsl:text>)</xsl:text>
                </xsl:if>
            
            </p>
        </xsl:if>
        
        <xsl:if test="doc:propertyType/doc:propertyTypeFile!=''">
            <a>
                <xsl:attribute name="href"><xsl:value-of select="doc:propertyType/doc:propertyTypeFile"/></xsl:attribute>
                <p class="einzug10"><xsl:value-of select="doc:propertyType/doc:propertyTypeName"/></p>
            </a>            
        </xsl:if>
                
        <xsl:if test="doc:enumeration/doc:enumerationItem/doc:id!=''"> 
            <br/>
            <table  width="800" border="0" cellspacing="3">
            <tr>
                <td width="70" height="20"  bgcolor="#9DE5F7">
                    <p><strong><em>Code</em></strong></p>
                </td>
                
                <td colspan="2" width="700" bgcolor="#9DE5F7">
                    <p><strong><em>Text</em></strong></p>
                </td>
            </tr>
          <xsl:for-each select="doc:enumeration/doc:enumerationItem">  
            <tr>
                <td width="70" bgcolor="#EEEEEE">
                    <p><xsl:value-of select="doc:id"/></p>
                </td>
                <td width="300" bgcolor="#EEEEEE">
                      <p><xsl:value-of select="doc:name"/></p>
                  </td>
                <td bgcolor="#EEEEEE">
                    <h4><xsl:value-of disable-output-escaping="yes" select="doc:description"/></h4>
                </td>
              </tr>

              <!--xsl:if test="doc:description!=''">
                  <tr>
                      <td colspan="2">
                          <h4><xsl:value-of select="doc:description"/></h4>
                      </td>
                  </tr>
              </xsl:if-->
          </xsl:for-each>
                
           </table>
        </xsl:if>
        
    </xsl:for-each>
     
</body>

</html>
 </xsl:template>   

<xsl:template match="*">
    
</xsl:template>
    
    
    
</xsl:stylesheet>
